#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "data_entry.h"
#include <unistd.h>
#include <libpq-fe.h>
#include <gdk/gdkkeysyms.h>
#include "pizza_utils.h"
#include "order_entry.h"

void changed_orders_report ()
{
	int i, nTuples;
	int j, nTuples2;
	int k, nTuples3;
	FILE *fp;
	PGresult *res2, *res3, *res4;
	float v,total;
	int the_order, the_store, the_customer;

	fp = fopen ("changed_orders.report", "w");
	if (!fp) return;

	// generate a history report file
	res = execSQL ("select distinct ordernum,store_id from ordhist order by store_id, ordernum DESC");
	nTuples = PQntuples (res);
	for (i = 0; i < nTuples; i++)
	{
		the_order = atoi(PQgetvalue (res,i,0));
		the_store = atoi(PQgetvalue (res,i,1));
		fprintf (fp, "Order: %d-%d\n", the_store, the_order);

		res4 = execSQL ("select is_pickup,pickup_name,pickup_time,custnum "
			"from orders where store_id = %d and ordernum = %d",
			the_store, the_order);
		if (PQntuples(res4) > 0)
		if (*PQgetvalue (res4,0,0) == 't')
		{
			fprintf (fp, "  Pickup: %s at %s\n\n",
				PQgetvalue (res4,0,1),
				PQgetvalue (res4,0,2));
		}
		else // get customer details
		{
			the_customer = atoi (PQgetvalue (res4, 0,3));
			PQclear (res4);
			res4 = execSQL ("select custname,address,suburb,phone from customers where "
				"custnum = %d", the_customer);
			fprintf (fp, "  Deliver to %s PH: %s\n", 
				PQgetvalue (res4,0,0),
				PQgetvalue (res4,0,3));
			fprintf (fp, "             %s,%s\n\n", 
				PQgetvalue (res4,0,1),
				PQgetvalue (res4,0,2));
		}
		PQclear (res4);

		// print out the latest one
			res3 = execSQL ("select item_code,description,qty,price,seq_num from ordet "
							"where ordernum = %d and store_id = %d "
							"order by seq_num",
							the_order, the_store);
			nTuples3 = PQntuples (res3);
			total = 0;
	
			for (k = 0; k < nTuples3; k++)
			{
				v = atof (PQgetvalue (res3,k,3));
				total += v;
				fprintf (fp, "%-5.5s %-50.50s %4.4s %s\n",
					PQgetvalue (res3, k, 0),
					PQgetvalue (res3, k, 1),
					PQgetvalue (res3, k, 2),
					money (v,MLEN)
					);
			}
	
			PQclear (res3);
			fprintf (fp, "\n                                                       Total: %s\n",
				money (total, 7));
			fprintf (fp, "----------------------------------------------------------------------\n\n");

		res2 = execSQL ("select distinct date from ordhist "
			"where ordernum = %d and store_id = %d order by date DESC",
			the_order, the_store);
		nTuples2 = PQntuples (res2);
		for (j = 0; j < nTuples2; j++)
		{
			fprintf (fp, " Date: %24.24s\n\n", PQgetvalue (res2,j,0));
			res3 = execSQL ("select item_code,description,qty,price,seq_num from ordhist "
							"where ordernum = %d and store_id = %d and date = '%24.24s' "
							"order by seq_num",
							the_order, the_store, PQgetvalue (res2,j,0));
			nTuples3 = PQntuples (res3);
			total = 0;
	
			for (k = 0; k < nTuples3; k++)
			{
				v = atof (PQgetvalue (res3,k,3));
				total += v;
				fprintf (fp, "%-5.5s %-50.50s %4.4s %s\n",
					PQgetvalue (res3, k, 0),
					PQgetvalue (res3, k, 1),
					PQgetvalue (res3, k, 2),
					money (v,MLEN)
					);
			}
	
			PQclear (res3);
			fprintf (fp, "\n                                                       Total: %s\n",
				money (total, 7));
			fprintf (fp, "----------------------------------------------------------------------\n\n");
		}
		PQclear (res2);
		fprintf (fp, "======================================================================\n\n");
	}
	PQclear (res);
	fclose (fp);
	
	display_file ("changed_orders.report");
}
