-----------------------
-- drop old functions

-- order functions
drop function total_price(orders);
drop function custname(orders);
drop function phone(orders);
drop function address(orders);
drop function suburb(orders);

-- customer functions
drop function total_spent(customers);

-- Create useful functions

create function total_order_price(orders) returns float8
	as 'select sum(price) from ordet where ordernum = $1.ordernum'
	language 'sql';

create function custname(orders) returns text
	as 'select custname from customers where custnum = $1.custnum'
	language 'sql';

create function phone(orders) returns text
	as 'select phone from customers where custnum = $1.custnum'
	language 'sql';

create function address(orders) returns text
	as 'select address from customers where custnum = $1.custnum'
	language 'sql';

create function suburb(orders) returns text
	as 'select suburb from customers where custnum = $1.custnum'
	language 'sql';

create function total_spent(customers) returns float8
	as 'select sum(ordet.price) from ordet, orders where ordet.ordernum = orders.ordernum and orders.custnum = $1.custnum'
	language 'sql';
